"""
Django settings for slo_django_wiki project.

Generated by 'django-admin startproject' using Django 4.1.5.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

from django.urls import reverse_lazy as reverse_url
from pathlib import Path

from .utils import (
    get_env,
    string_to_bool,
    string_to_list,
)

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = get_env(
    'WIKI_SECRET_KEY',
    '',
)

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = string_to_bool(
    get_env(
        'WIKI_DEBUG',
        'False',
    )
)

ALLOWED_HOSTS = string_to_list(
    get_env(
        'WIKI_ALLOWED_HOSTS',
        '127.0.0.1, localhost',
    )
)

SITE_ID = 1

# Reverse proxy

if string_to_bool(get_env('WIKI_REVERSE_PROXY', 'no')):
    SECURE_PROXY_SSL_HEADER = ('HTTP_X_FORWARDED_PROTO', 'https')

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    # Django wiki part
    'django.contrib.sites.apps.SitesConfig',
    'django.contrib.humanize.apps.HumanizeConfig',
    'django_nyt.apps.DjangoNytConfig',
    'mptt',
    'sekizai',
    'sorl.thumbnail',
    'wiki.apps.WikiConfig',
    'wiki.plugins.attachments.apps.AttachmentsConfig',
    'wiki.plugins.editsection.apps.EditSectionConfig',
    'wiki.plugins.globalhistory.apps.GlobalHistoryConfig',
    'wiki.plugins.help.apps.HelpConfig',
    'wiki.plugins.notifications.apps.NotificationsConfig',
    'wiki.plugins.links.apps.LinksConfig',
    'wiki.plugins.images.apps.ImagesConfig',
    'wiki.plugins.macros.apps.MacrosConfig',

    # Django registration part
    'django_registration',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'slo_django_wiki.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [BASE_DIR / 'templates'],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'sekizai.context_processors.sekizai',
            ],
        },
    },
]

WSGI_APPLICATION = 'slo_django_wiki.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

# Get the database engine name
WIKI_DATABASE_ENGINE = get_env('WIKI_DATABASE_ENGINE', 'sqlite')

if WIKI_DATABASE_ENGINE == 'sqlite':
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': '/sqlite/db.sqlite3',
        }
    }
if WIKI_DATABASE_ENGINE in ['postgresql', 'postgres']:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': get_env('WIKI_DATABASE_PG_BASE_NAME', 'slo_wiki'),
            'USER': get_env('WIKI_DATABASE_PG_USER', 'slo_wiki'),
            'PASSWORD': get_env('WIKI_DATABASE_PG_PASSWORD', ''),
            'HOST': get_env('WIKI_DATABASE_PG_HOST', '127.0.0.1'),
            'PORT': get_env('WIKI_DATABASE_PG_PORT', '5432'),
        }
    }


# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/
LOCALE_PATHS = [
    BASE_DIR / 'locale',
]

LANGUAGE_CODE = get_env('WIKI_LANGUAGE_CODE', 'fr-ch')

TIME_ZONE = get_env('WIKI_TIME_ZONE', 'Europe/Zurich')

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/

STATIC_URL = get_env('WIKI_STATIC_URL', '/static/')
STATIC_ROOT = get_env('WIKI_STATIC_ROOT', '/static')

MEDIA_URL = get_env('WIKI_MEDIA_URL', '/media/')
MEDIA_ROOT = get_env('WIKI_MEDIA_ROOT', '/media')

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'


# Wiki config

# Empty

# Registration config

# Deactivate the account handling by Django-wiki
WIKI_ACCOUNT_HANDLING = False

# Number of days users will have to activate their accounts after
# registering
ACCOUNT_ACTIVATION_DAYS = int(
    get_env(
        'WIKI_ACCOUNT_ACTIVATION_DAYS',
        '7',
    )
)

REGISTRATION_SALT = 'VFNCifnUQnHLGRibtNbiruVCxdmbqz'

# Login and logout default redirect
LOGIN_REDIRECT_URL = '/'
LOGOUT_REDIRECT_URL = '/'

# URL to logout
LOGOUT_URL = reverse_url('logout')

# Email config

# Default email address to use in the "from" field
DEFAULT_FROM_EMAIL = get_env(
    'WIKI_DEFAULT_FROM_EMAIL',
    '',
)

# E-mail backend, only smtp and console for now
choosed_email_backend = get_env(
    'WIKI_EMAIL_BACKEND',
    'console',
)

if choosed_email_backend == 'smtp':
    # Use SMTP backend
    EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
    EMAIL_HOST = get_env(
        'WIKI_EMAIL_HOST',
        'localhost',
    )
    EMAIL_PORT = get_env(
        'WIKI_EMAIL_PORT',
        25,
    )
    EMAIL_USE_TLS = string_to_bool(
        get_env(
            'WIKI_EMAIL_USE_TLS',
            'False',
        )
    )
    EMAIL_USE_SSL = string_to_bool(
        get_env(
            'WIKI_EMAIL_USE_SSL',
            'False',
        )
    )
    EMAIL_HOST_USER = get_env(
        'WIKI_EMAIL_HOST_USER',
        '',
    )
    EMAIL_HOST_PASSWORD = get_env(
        'WIKI_EMAIL_HOST_PASSWORD',
        '',
    )

else:
    # Print the sent emails on the stdout
    EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'

